var perPage = 4;
var msgTimeout = 5000;

(function ($) {
    $(function () {
        
        $('.expiry').mask("99/99", {placeholder: "MM/YY"});

        $(document).off('click', '#member-logout');
        $(document).on('click', '#member-logout', function (event) {
            window.location.href = OFFER_PATH + 'member/logout.php';
        });


        $(document).off('click', '#member-home');
        $(document).on('click', '#member-home', function (event) {
            window.location.href = OFFER_PATH + 'home.php';
        });

        $(document).off('click', '#error_handler_overlay_close');
        $(document).on('click', '#error_handler_overlay_close', function (event) {
            event.preventDefault ? event.preventDefault() : (event.returnValue = false);
            $('#error_handler_overlay').remove();
        });

        $(document).off('submit', '[name=customer_order_details]');
        $(document).on('submit', '[name=customer_order_details]', function (event) {
            event.preventDefault ? event.preventDefault() : (event.returnValue = false);
            if (!validateFormData($(this)))
            {
                return false;
            }
            updateOrderCustomer('form[name=customer_order_details]');
        });

        $(document).off('submit', '[name=order_subscription_details]');
        $(document).on('submit', '[name=order_subscription_details]', function (event) {
            event.preventDefault ? event.preventDefault() : (event.returnValue = false);
            if (!validateFormData($(this), 'Update Subscription', true))
            {
                return false;
            }
            updateOrderCustomer('form[name=order_subscription_details]');
            $('[name=order_subscription_details]').addClass('disabled');
            $('.loader').show();
        });
        
        $(document).off('submit', '[name=creditcard_details]');
        $(document).on('submit', '[name=creditcard_details]', function (event) {
            event.preventDefault ? event.preventDefault() : (event.returnValue = false);
            var isValid = true;
            if (!validateFormData($(this), 'Update Payment Information', true))
            {
                isValid = false;
            }
            var obj = $('[name=expiry]');
            var expiryData = $(obj).val();
            if(expiryData){
                expiryDataArray = expiryData.split('/');
                var currentMonth = new Date().getMonth();
                var currentYear = new Date().getYear();
                if(expiryDataArray[0] > 12 && expiryDataArray[0] < 1){
                    $(obj).next('.error-msg').html('Invalid expiry month!');
                    isValid = false;
                }
                if(expiryDataArray[1] < (currentYear - 100)){
                    $(obj).next('.error-msg').html('Invalid expiry year!');
                    isValid = false;
                }

                if(currentMonth <= 8 && expiryDataArray[0] <= currentMonth + 3 && expiryDataArray[1] == (currentYear - 100)){
                    $(obj).next('.error-msg').html('Card will expire soon!');
                    isValid = false;
                }
            }
            else{
                $(obj).next('.error-msg').html('Please enter a valid expiry date!');
                isValid = false;
            }
            

            if(!isValid)
            {
                return false;
            }

            $(this).addClass('disabled');
            $('.loader').show();

            $('[name=expmonth]').val(expiryDataArray[0]);
            $('[name=expyear]').val(expiryDataArray[1]);

            updateCreditCardDetails('form[name=creditcard_details]');
        });

        $(document).off('submit', '[name=login]');
        $(document).on('submit', '[name=login]', function (event) {
            event.preventDefault ? event.preventDefault() : (event.returnValue = false);
            if (!validateFormData($(this)))
            {
                return false;
            }
            memberLogin('form[name=login]');
        });

        $(document).off('submit', '[name=update-password]');
        $(document).on('submit', '[name=update-password]', function (event) {
            event.preventDefault ? event.preventDefault() : (event.returnValue = false);
            if (!validateFormData($(this)))
            {
                return false;
            }
            memberUpdate('form[name=update-password]');
        });
        
        $(document).off('submit', '[name=forgot-password]');
        $(document).on('submit', '[name=forgot-password]', function (event) {
            event.preventDefault ? event.preventDefault() : (event.returnValue = false);
            if (!validateFormData($(this)))
            {
                return false;
            }
            memberForgotPassword('form[name=forgot-password]');
        });
        
        $(document).off('submit', '[name=reset-password]');
        $(document).on('submit', '[name=reset-password]', function (event) {
            event.preventDefault ? event.preventDefault() : (event.returnValue = false);
            if (!validateFormData($(this)))
            {
                return false;
            }
            memberRessetPassword('form[name=reset-password]');
        });
        
        $(document).off('submit', '[name=cancel-order]');
        $(document).on('submit', '[name=cancel-order]', function (event) {
            event.preventDefault ? event.preventDefault() : (event.returnValue = false);
            if (!validateFormData($(this), 'Cancel Order', true))
            {
                return false;
            }

            cancelOrder('form[name=cancel-order]');
            $('[name=cancel_order]').addClass('disabled');
            $('.loader').show();
        });
        
        $(document).off('submit', '[name=refund-order]');
        $(document).on('submit', '[name=refund-order]', function (event) {
            event.preventDefault ? event.preventDefault() : (event.returnValue = false);
            if (!validateFormData($(this), 'Refund Order', true)) {
                return false;
            }
            var orderAmt = $('[name=order_total]').val();
            var refundAmt = $('[name=refund_amount]').val();
            if(parseFloat(orderAmt) < parseFloat(refundAmt))
            {
                showMessage('#msg', 'error', 'Refund amount should be less than or equal to the order amount');
                clearMessage('#msg', msgTimeout);
                return false;
            }
            refundOrder('form[name=refund-order]');
            $('[name=refund_order]').addClass('disabled');
            $('.loader').show();

        });

        $(document).off('submit', '[name=usps_track]');
        $(document).on('submit', '[name=usps_track]', function (event) {
            event.preventDefault ? event.preventDefault() : (event.returnValue = false);
            if (!validateFormData($(this), 'Track My Order', true)) {
                return false;
            }

            $.ajax({
                url: '../' + AJAX_PATH + 'extensions/membership/track-order',
                method: 'post',
                data: { tracking_id: $('[name=tracking_id]').val() },
                success: function (data) {
                    console.log(data);
                    $('#track_details').html(data.trackDetails);
                    $('#status_code').val(data.statusCode);
                    $('#track_summary').html(data.trackSummary);
                }
            });
        });

        $(document).off('click', '.rec-li');
        $(document).on('click', '.rec-li', function (event) {
            $('.rec-li').removeClass('active');
            $(this).addClass('active');
            var orderId = $(this).data('id');
            var rawJson = $('#'+orderId + '-order').text();
            var orderData = '';
            if(rawJson !== '')
            {
                orderData = $.parseJSON(rawJson);
            }
            populateSideBarDetails(orderData);
            //console.log(orderData);
        });

        if ($('#order-lists').length)
        {
            getAllCustomerOrders($('.order-data'), false, '', '', '', 1, perPage);
        }

        if ($('.dashboard-ui').length)
        {
            getAllCustomerOrders($('.dashboard-ui'), true);
        }

        getCountries('shipping_country', 'shipping_state');
        getCountries('billing_country', 'billing_state');

        var cc_expiration_date = $('[name=cc_expiration_date]').val();

        if (typeof (cc_expiration_date) != 'undefined') {
            var exp_month = cc_expiration_date.substring(0, 2);
            var exp_year = cc_expiration_date.substring(2, 4);
            $('[id=expmonth]').val(exp_month);
            $('[id=expyear]').val(exp_year);
        }

        $(document).off('change', '[id=expmonth]');
        $(document).on('change', '[id=expmonth]', function (event) {
            var expMonth = $('[id=expmonth]').val();
            var expDate = expMonth + $('[id=expyear]').val();
            console.log(expDate);
            $('[name=cc_expiration_date]').val(expDate);
        });

        $(document).off('change', '[id=expyear]');
        $(document).on('change', '[id=expyear]', function (event) {
            var expYear = $('[id=expyear]').val();
            var expDate = $('[id=expmonth]').val() + expYear;
            console.log(expDate);
            $('[name=cc_expiration_date]').val(expDate);
        });

        // $('.datepicker').datepicker({
        //     format: 'mm/dd/yyyy',
        //     weekStart: 1,
        //     daysOfWeekHighlighted: "6,0",
        //     autoclose: true,
        //     todayHighlight: true
        // });

        // $('.datepicker').datepicker().on('changeDate', function (ev) {
        //     $('[name=recurring_date]').val($(this).val());
        // });

        // Search Order By ID

        $(document).off('click', '.search-order');
        $(document).off('keypress', '[name=search-order]');
        $(document).on('keypress', '[name=search-order]', function (event) {
            if(event.which == 13) {
                var orders = $(this).val();
                getAllCustomerOrders($('.order-data'), false, orders);
            }
        });

        $(document).off('click', '.search-order');
        $(document).on('click', '.search-order', function (event) {
            var orders = $(this).val();
            getAllCustomerOrders($('.order-data'), false, orders);
        });

        // $(document).off('click', '.billing-same');
        // $(document).on('click', '.billing-same', function (event) {
        //     var checked = $(this).is(':checked');
        //     if(checked){
        //         $('.billing-box').show();
        //     }else{
        //         $('.billing-box').hide();
        //     }
        // });

        // Search Order By ID


        // Datepicker custom range

        var start = moment().subtract(29, 'days');
        var end = moment();

        function cb(start, end) {
           var calenderVal = start.format('DD/MM/YYYY') + ' - ' + end.format('DD/MM/YYYY');
           $('#reportrange').val(calenderVal);
           $('#range-text').text(calenderVal);
           getAllCustomerOrders($('.order-data'), false, '', start.format('MM/DD/YYYY'), end.format('MM/DD/YYYY'));
        }

       $('#reportrange').daterangepicker({
           autoUpdateInput: false,
           locale: {
               cancelLabel: 'Clear'
           },
           startDate: start,
           endDate: end,
           ranges: {
               'Today': [moment(), moment()],
               'Yesterday': [moment().subtract(1, 'days'), moment().subtract(1, 'days')],
               'Last 7 Days': [moment().subtract(6, 'days'), moment()],
               'Last 30 Days': [moment().subtract(29, 'days'), moment()],
               'This Month': [moment().startOf('month'), moment().endOf('month')],
               'Last Month': [moment().subtract(1, 'month').startOf('month'), moment().subtract(1, 'month').endOf('month')]
            }
       }, cb);

        $('#subscription_datepicker').daterangepicker({
            singleDatePicker: true,
            showDropdowns: true,
            minYear: 1901,
            maxYear: parseInt(moment().format('YYYY'), 10)
        }, function (start, end, label) {

        });

        $('#subscription_datepicker').on('apply.daterangepicker', function (ev, picker) {
            let selectedDate = $('#subscription_datepicker').val();
            $('[name=recurring_date]').val(selectedDate);
        });
        

        $(document).off('click', '.fa-calendar-alt');
        $(document).on('click', '.fa-calendar-alt', function (event) {
            $('#subscription_datepicker').trigger('click');
        });


        $(document).off('click', '.edit-payment-details');
        $(document).on('click', '.edit-payment-details', function (event) {
            //$('.error-panel').removeClass('hide-inline');
            $('.common-pop-head').html('Update Payment Information');
            $('.payment-content').show();
            $('.common-popup').addClass('is-visible');
        });

        $(document).off('click', '.edit-subscription-details');
        $(document).on('click', '.edit-subscription-details', function (event) {
            //$('.error-panel').removeClass('hide-inline');
            $('.common-pop-head').html('Update Subscription');
            $('.subscription-content').show();
            $('.common-popup').addClass('is-visible');
        });

        $(document).off('click', '.edit-recurring-product');
        $(document).on('click', '.edit-recurring-product', function (event) {
            //$('.error-panel').removeClass('hide-inline');
            $('.common-pop-head').html('Update Subscription');
            $('.subscription-content').show();
            $('.common-popup').addClass('is-visible');
        });

        $(document).off('click', '.close-btn, .back-in-btn');
        $(document).on('click', '.close-btn, .back-in-btn', function (event) {
          $('.sidebar-wrapper').removeClass('is-visible');
          $('.sidebar-info').hide();
          $('.error-msg').html('');
          $('.common-pop-head').html('');
        });

        $(document).off('click', '.close-panel');
        $(document).on('click', '.close-panel', function (event) {
            $(this).parent().addClass('hide-inline');
            $('.message-panel').addClass('hide-inline');
            $('#success-msg-header').html('');
            $('#error-msg-header').html('');
        });

        $(document).off('click', '.page-link');
        $(document).on('click', '.page-link', function (event) {
            if($(this).hasClass('prev-page') || $(this).hasClass('next-page'))
            {
                return;
            }
            $('.page-item').removeClass('active');
            $('.page-item').removeClass('disabled');
            $(this).parent().addClass('active');
            if($(this).data('page-id') > 1)
            {
                $('.prev-page').data('page-id', $(this).data('page-id') - 1)
                $('.next-page').data('page-id', $(this).data('page-id') + 1)
            }
            
            getAllCustomerOrders($('.order-data'), false, '', '', '', $(this).data('page-id'), perPage, false);
        });

        $(document).off('click', '.prev-page');
        $(document).on('click', '.prev-page', function (event) {
            var pageid = $('.page-item.active a').data('page-id');
            pageid = (pageid == 1 ? 1 : pageid -1);
            $('.page-item').removeClass('active');
            $('.page-item').removeClass('disabled');
            $('.page-link[data-page-id='+pageid+']').parent().addClass('active');
            getAllCustomerOrders($('.order-data'), false, '', '', '', pageid, perPage, false);
        });

        $(document).off('click', '.next-page');
        $(document).on('click', '.next-page', function (event) {
            var pageid = $('.page-item.active a').data('page-id');
            pageid = pageid + 1;
            $('.page-item').removeClass('active');
            $('.page-item').removeClass('disabled');
            $('.page-link[data-page-id='+pageid+']').parent().addClass('active');
            getAllCustomerOrders($('.order-data'), false, '', '', '', pageid, perPage, false);
        });

    });

    // popups track, refund & cancel order
    $(document).on('click', '.action-drop-list li a', function (event) {
        event.preventDefault ? event.preventDefault() : (event.returnValue = false);

        if ($(this).attr('class') == 'track-order') {
            $('[name=tracking_id]').val($(this).attr('data-trackingID'));
            $('.common-pop-head').html('Track My Order');
            $('.order-tracking-content').show();
            $('.common-popup').addClass('is-visible');
        }
        if ($(this).attr('class') == 'refund-order') {
            $('[name=order_id]').val($(this).attr('data-orderID'));
            $('[name=refund_amount]').val($(this).attr('data-orderTotal'));
            $('<input>').attr({ type: 'hidden', name: 'order_total' }).appendTo('form');
            $('[name=order_total]').val($(this).attr('data-orderTotal'));
            $('.common-pop-head').html('Refund Order');
            $('.order-refund-content').show();
            $('.common-popup').addClass('is-visible');
        }
        if ($(this).attr('class') == 'cancel-order') {
            $('[name=order_id]').val($(this).attr('data-orderID'));
            $('.common-pop-head').html('Cancel Order');
            $('.order-cancel-content').show();
            $('.common-popup').addClass('is-visible');
        }
    });

    // $('.popup-btn').on('click', function () {
    //     $('.error-msg').html('');
    //     $('.sidebar-wrapper').removeClass('is-visible');
    // });

    // $('.popup-cancel-btn').on('click', function () {
    //     $('.error-msg').html('');
    //     $('.sidebar-wrapper').removeClass('is-visible');
    // });

})(jQuery);


var _self = $(this);
var errors = [];

var defaults = {
    errorModal: true,
    autoFillFormElement: false,
    countryDropdown: 'Select Country',
    ajaxLoader: {
        div: '',
        timeInOut: 0
    },
    responseLoader: {
        div: '',
        timeInOut: 0
    }
};
var _selfOptions = $.extend({}, defaults, _selfOptions);

var header = document.getElementById("myHeader");
if (header !== null)
{
    var sticky = header.offsetTop;
}


function fixedScroll() {
    if (window.pageYOffset >= sticky) {
        header.classList.add("sticky");
    } else {
        header.classList.remove("sticky");
    }
}

function doAjaxCall(path, formData) {
    $.ajax({
        url: '../' + AJAX_PATH + 'extensions/membership/' + path,
        method: 'post',
        data: formData,
        beforeSend: function () {
            showLoader();
        },
        success: function (data) {
            console.log(data);
            hideLoader();
            modifyResponse(path, data);
        }
    });
}

function modifyResponse(path, data)
{
    switch (path)
    {
        case 'update-order':
            $('[name=order_subscription_details]').removeClass('disabled');
            $('.loader').hide();
            if (typeof data == 'object' && data.response_code == 100) {
                showMessage('#msg', 'success', 'Order data has been updated successfully.');
            }
            else {
                showMessage('#msg', 'error', 'Something went wrong.');
            }
            clearMessage('#msg', msgTimeout);
            break;
        case 'member-login':
            if (typeof data == 'object' && data.response_code == 100) {
                doAjaxCall('set-member-data', data);
            }
            else {
                if(typeof(data.message) == 'undefined') {
                    data.message = 'Email or Password Incorrect';
                }
                showMessage('#msg', 'alert alert-danger', data.message);
                clearMessage('#msg', msgTimeout);
            }
            break;
        case 'set-member-data':
            window.location.href = OFFER_PATH + "member/dashboard.php";
            break;
        case 'member-update':
            if (typeof data == 'object' && data.response_code == 100) {
                showMessage('#msg', 'alert alert-success', data.message);
                lazyRedirect("member/login.php", 2000);
            } else {
                showMessage('#msg', 'alert alert-danger', data.message);
                clearMessage('#msg', msgTimeout);
            }
            break;
        case 'forgot-password':
            if (typeof data == 'object' && data.response_code == 100) {
                showMessage('#msg', 'alert alert-success', data.message);
                lazyRedirect("member/reset-password.php", 2000);                
            } else {
                showMessage('#msg', 'alert alert-danger', data.message);
                clearMessage('#msg', msgTimeout);
            }
            break;          
        case 'reset-password':
            if (typeof data == 'object' && data.response_code == 100) {
                showMessage('#msg', 'alert alert-success', data.message);
                lazyRedirect("member/login.php", 2000);                
            } else {
                showMessage('#msg', 'alert alert-danger', data.message);
                clearMessage('#msg', msgTimeout);
            }
            break;
        case 'cancel-order':
            $('[name=cancel_order]').removeClass('disabled');
            $('.loader').hide();
            if (typeof data == 'object' && data.response_code == 100) {
                showMessage('#msg', 'success', 'Your order has been cancelled successfully.');
            }
            else {
                showMessage('#msg', 'error', 'Something went wrong.');
            }
            getAllCustomerOrders($('.order-data'), false, '', '', '', 1, perPage, false, true);
            clearMessage('#msg', msgTimeout);
            //lazyRedirect("member/orders.php", 2000); 
            break;
        case 'refund-order-request':
            $('[name=refund_order]').removeClass('disabled');
            $('.loader').hide();
            if (typeof data == 'object' && data.response_code == 100) {
                showMessage('#msg', 'success', 'Your order refund request has been initiated.');
            }
            else {
                showMessage('#msg', 'error', 'Something went wrong.');
            }
            getAllCustomerOrders($('.order-data'), false, '', '', '', 1, perPage, false, true);
            clearMessage('#msg', msgTimeout);
            ////lazyRedirect("member/orders.php", 2000); 
            break;
        case 'update-creditcard-details':
            $('[name=creditcard_details]').removeClass('disabled');
            $('.loader').hide();
            if (typeof data == 'object' && data.response_code == 100) {
                showMessage('#msg', 'success', 'Credit card details updated successfully.');
                clearMessage('#msg', msgTimeout);            
            } else {
                showMessage('#msg', 'error', 'Something went wrong.');
                clearMessage('#msg', msgTimeout);
            }
            break;
    }
}

function lazyRedirect(url, time)
{
    setTimeout(function () {
        window.location.href = OFFER_PATH + url;
     }, time);
}

function updateOrderCustomer(form) {
    doAjaxCall('update-order', $(form).serialize());
}

function updateCreditCardDetails(form) {
    doAjaxCall('update-creditcard-details', $(form).serialize());
}

function clearMessage(selector, timeout)
{
    setTimeout(function () {
        $('.message-panel').addClass('hide-inline');
        $('#success-msg-header').html('');
        $('#error-msg-header').html('');
    }, timeout);
}

function memberLogin(form) {
    doAjaxCall('member-login', $(form).serialize());
}

function memberForgotPassword(form) {
    doAjaxCall('forgot-password', $(form).serialize());
}

function memberResetPassword(form) {
    doAjaxCall('reset-password', $(form).serialize());
}

function cancelOrder(form) {
    doAjaxCall('cancel-order', $(form).serialize());
}

function refundOrder(form) {
    doAjaxCall('refund-order-request', $(form).serialize());
}

function memberUpdate(form) {
    doAjaxCall('member-update', $(form).serialize());
}

function getAllCustomerOrders(obj, is_dashboard = false, orders = '', startdaterange = '', enddaterange = '', page = 1, limit = 5, showpagination = true, skipPagination = false) {
    $('#loader').show();
    if(!is_dashboard)
    {
        var start = moment().subtract(29, 'days');
        var end = moment();
        var calenderVal = start.format('DD/MM/YYYY') + ' - ' + end.format('DD/MM/YYYY');

        if (startdaterange != '' && enddaterange != '') {
            calenderVal = startdaterange + ' - ' + enddaterange;
        }

        $('#reportrange').val(calenderVal);
        $('#range-text').text(calenderVal);
        if(startdaterange == ''){
            startdaterange = start.format('MM/DD/YYYY');
        } 
        if(enddaterange == ''){
            enddaterange = end.format('MM/DD/YYYY');
        } 
        $('.orders-place-holders').show();
        $('.tr-rec').hide();
    }
    $.ajax({
        url: '../' + AJAX_PATH + 'extensions/membership/get-orders',
        method: 'post',
        data:{
            is_dashboard : is_dashboard,
            order_ids : orders,
            start_date : startdaterange,
            end_date : enddaterange,
            page : page,
            limit : limit
        },
        success: function (data) {
            $('#loader').hide();
            if (typeof data != 'undefined' && data != '')
            {
                var finalData = $.parseJSON(data);
                if (typeof finalData.raw != 'undefined' || finalData.raw != null) {
                    if (finalData.raw.total_results <= 5) {
                        skipPagination = true;
                    }
                }
                $(obj).html(finalData.formatted);
                
                if(!is_dashboard)
                {
                    $('.orders-place-holders').hide();
                    $('.tr-rec').show();
                    if (!skipPagination) {
                        $('#total-rec').html(finalData.totalRec);
                        $('#curr-page-rec').html(finalData.currentPageRec);
                        var paginationCount = finalData.pagination;
                        var pagination = '<li class="page-item"><a class="page-link prev-page" href="javascript:void(0);">Prev</a></li>';
                        if(paginationCount > 1)
                        {
                            for(var i=1; i<=paginationCount; i++){
                                pagination += '<li class="page-item '+ (i==1 ? "active":"") +'"><a data-page-id="'+i+'" class="page-link" href="javascript:void(0);">'+ i +'</a></li>'
                            }
                        }
                        else{
                            pagination += '<li class="page-item active"><a class="page-link" href="javascript:void(0);">1</a></li>';
                        }
                        pagination += '<li class="page-item"><a class="page-link next-page" data-total-count="'+paginationCount+'" href="javascript:void(0);">Next</a></li>';

                        if(showpagination)
                        {
                            $('.pagination').html(pagination);
                        }

                        if(page==paginationCount){
                            $('.next-page').parent().addClass("disabled");
                        }
                        if(page==1){
                            $('.prev-page').parent().addClass("disabled");
                        }
                    }
                    
                }
                else{
                    var parseJsonData = '';
                    if(finalData.initialData)
                    {
                        parseJsonData = $.parseJSON(finalData.initialData);
                    }
                    populateSideBarDetails(parseJsonData);
                    $('.animated-background').hide();
                }

            }
            else
            {
                $(obj).html('<div class="row" ><div class="col-sm-12">No Record found</div></div>');
            }

        }
    });
}

function populateSideBarDetails(data){
    if(data == ''){
        $('.order-details-panel').html('<li>NA</li>');
        return;
    }
    $('#sidebar-oid').text(data.order_id);
    $('#order-dt').text(data.order_date);
    $('#order-nxt-r-dt').text(data.order_next_rec_pro_date ? data.order_next_rec_pro_date : 'NA');
    $('#order-nxt-r-nm').text(data.order_next_rec_pro_name ? data.order_next_rec_pro_name : 'NA');
    $('#order-nxt-r-price').text(data.order_total);

    var shipAddress = '';
    var billAddress = '';
    
    
    if(data.shipping_street_address2){
        shipAddress = data.shipping_street_address +', '+ data.shipping_street_address2+', '+ data.shipping_city+', '+ data.shipping_state+', '+ data.shipping_postcode+', '+data.shipping_country;
    }
    else{
        shipAddress = data.shipping_street_address +', '+ data.shipping_city+', '+ data.shipping_state+', '+ data.shipping_postcode+', '+data.shipping_country;
    }
    if(data.billing_street_address2){
        billAddress = data.billing_street_address +', '+ data.billing_street_address2+', '+ data.billing_city+', '+ data.billing_state+', '+ data.billing_postcode+', '+data.billing_country;
    }
    else{
        billAddress = data.billing_street_address +', '+ data.billing_city+', '+ data.billing_state+', '+ data.billing_postcode+', '+data.billing_country;
    }

    $('#order-ship-add').text(shipAddress);
    $('#order-bill-add').text(billAddress);
}

function showMessage(headTitle, type, message) {
    $('.' + type +'-panel').removeClass('hide-inline');
    $('#' + type +'-msg-header').html(message);
}


function getCountries(countryElementName, stateElementName) {
    var countryElement = $('select[name=' + countryElementName + ']');
    var selectedCountryName = countryElement.data('selected');
    var countryElementHtml = '';
    var no_of_countries = 0;
    $.each(app_config.allowed_country_codes, function ($key, countryCode) {
        if (app_config.countries.hasOwnProperty(countryCode)) {
            no_of_countries++;
            countryElementHtml += '<option value="' + countryCode + '">' + app_config.countries[countryCode]['name'] + '</option>';
        }
    });
    if (no_of_countries != 1) {
        countryElementHtml = '<option value="">' + _selfOptions.countryDropdown + '</option>' + countryElementHtml;
    }

    countryElement.html(countryElementHtml).trigger('change');
    if (typeof selectedCountryName !== 'undefined' && selectedCountryName.length) {
        countryElement.val(selectedCountryName).trigger('change');
    }
    getStates(stateElementName, countryElementName);
}

function getStates(stateElementName, countryElementName) {
    var stateElement = $('input[name=' + stateElementName + ']');
    var selectedStateName = stateElement.data('selected');
    var countryElement = $('select[name=' + countryElementName + ']');
    if (countryElement.length === 0 || $(countryElement).val() === '') {
        return;
    }
    var stateElementHtml = '';
    var zipElementName = countryElementName.replace('Country', '') + 'Zip';
    if (app_config.country_lang_mapping.hasOwnProperty(countryElement.val())) {
        $('[name=' + stateElementName + ']').closest('p, div, tr').find('label').text(app_config.country_lang_mapping[countryElement.val()].state);
        $('[name=' + zipElementName + ']').closest('p, div, tr').find('label').text(app_config.country_lang_mapping[countryElement.val()].zip);
    } else {
        $('[name=' + stateElementName + ']').closest('p, div, tr').find('label').text('State: ');
        $('[name=' + zipElementName + ']').closest('p, div, tr').find('label').text('Zip: ');
    }
    $.each(app_config.countries[countryElement.val()]['states'], function (stateCode, value) {
        if (stateCode.length && countryElement.val() == 'US' && stateCode.match(/Armed Forces/) != null) {
            return;
        }
        stateElementHtml += '<option value="' + stateCode + '">' + value.name + '</option>';
    });
    if (stateElementHtml.length) {
        if (!$('select[name=' + stateElementName + ']').length) {
            var classes = stateElement.attr('class');
            $('<select name="' + stateElementName + '"/>').insertAfter(stateElement);
            var attributes = stateElement.get(0).attributes;
            stateElement.remove();
            addAttributesToElement($('select[name=' + stateElementName + ']'), attributes);
        }
        var stateLable = 'State';
        if (
                typeof (app_config.country_lang_mapping[countryElement.val()]) !== 'undefined' &&
                typeof (app_config.country_lang_mapping[countryElement.val()].state) !== 'undefined' &&
                (app_config.country_lang_mapping[countryElement.val()].state) != '')
        {
            stateLable = (app_config.country_lang_mapping[countryElement.val()].state).slice(0, -1);
        }
        var stateDefaultElementHtml = "<option value='' selected='selected'>Select " + stateLable + "</option>";
        $('select[name=' + stateElementName + ']').html(stateDefaultElementHtml + stateElementHtml);
        if (selectedStateName) {
            $('select[name=' + stateElementName + ']').val(selectedStateName);
        }
    } else {
        if ($('input[name=' + stateElementName + ']').length === 0) {
            stateElement = $('select[name=' + stateElementName + ']');
            $('<input type="text" name="' + stateElementName + '" readonly />').insertAfter(stateElement);
            var attributes = stateElement.get(0).attributes;
            stateElement.remove();
            addAttributesToElement($('input[name=' + stateElementName + ']'), attributes);
        }
        $('input[name=' + stateElementName + ']').removeAttr('readonly');
    }
}

function addAttributesToElement(element, attributes) {
    for (var i in attributes) {
        if (typeof attributes[i] !== 'object') {
            continue;
        }
        element.attr(attributes[i].name, attributes[i].value);
    }
}


function errorHandler(errors, section) {
    showMessage(section, '', getUI(errors));
    clearMessage('#msg', msgTimeout);
    return;
}

function getUI(errors) {
    var msg = '';
    $.each(errors, function (key, value) {
        msg += value + '</br>';
    });
    return msg;
}

function validateFormData(form, section = '', inline = false) {
    errors = [];
    $('.error-msg').html('');
    $(form).find('input, select, textarea').not('[type=hidden], [type=submit]').each(function () {

        if ($(this).val() == '' && $(this).hasClass('required'))
        {
            if(inline)
            {
                $(this).next('.error-msg').html($(this).data('error-message'));
            }
            errors.push($(this).data('error-message'));
            
        }
    });

    if (errors.length > 0)
    {
        if(!inline)
        {
            errorHandler(errors, section);
        }
        return false;
    }
    return true;
}

function showLoader() {
    $('#loading-indicator').show();
}

function hideLoader() {
    $('#loading-indicator').hide();
}
